module.exports = {
	root: true,
	env: {
		node: true,
		browser: true,
	},
	rules: {
        "key-spacing": ["error", { "align": "value" }],
		"eqeqeq": ["error", "always"],
		"arrow-spacing": [
			"error",
			{
				before: true,
				after: true
			}
		],
		"no-console": "off",
		"no-useless-escape": "error",
		"no-control-regex": "off",
		indent: ["error", "tab"],
		"func-call-spacing": ["error", "never"],
		quotes: ["error", "double"],
		"comma-spacing": [
			"error",
			{
				before: false,
				after: true,
			},
		],
		"comma-style": ["error", "last"],
		"no-multiple-empty-lines": [
			"error",
			{
				max: 1,
				maxEOF: 0,
			},
		],
		"no-shadow-restricted-names": "error",
		"no-unexpected-multiline": "error",
		"no-shadow": [
			"error",
			{
				builtinGlobals: false,
				hoist: "functions",
				allow: [],
			},
		],
		"no-unmodified-loop-condition": "error",
		"no-unneeded-ternary": [
			"error",
			{
				defaultAssignment: false,
			},
		],
		"no-unreachable": "error",
		"no-unsafe-finally": "error",
		"no-unsafe-negation": "error",
		"no-unused-expressions": [
			"error",
			{
				allowShortCircuit: true,
				allowTernary: true,
				allowTaggedTemplates: true,
			},
		],
		"prefer-const": [
			"error",
			{
				destructuring: "all",
			},
		],
		"space-before-blocks": ["error", "always"],
		"space-before-function-paren": ["error", "never"],
		"prefer-arrow-callback": "error",
		"object-curly-newline": ["error", {
			minProperties: 1,
		}],
		"space-in-parens": ["error", "never"],
		"space-infix-ops": "error",
		"space-unary-ops": [
			"error",
			{
				words: true,
				nonwords: false,
			},
		],
		"spaced-comment": [
			"error",
			"always",
			{
				line: {
					markers: ["*package", "!", "/", ",", "="],
				},
				block: {
					balanced: true,
					markers: ["*package", "!", ",", ":", "::", "flow-include"],
					exceptions: ["*"],
				},
			},
		],
		"no-use-before-define": [
			"error",
			{
				functions: false,
				classes: false,
				variables: false,
			},
		],
		"no-useless-call": "error",
		"no-useless-computed-key": "error",
		"no-useless-constructor": "error",
		"no-useless-rename": "error",
		"no-useless-return": "error",
		"no-whitespace-before-property": "error",
		"no-trailing-spaces": "error",
		semi: ["error", "always"],
		"comma-dangle": ["error", "always-multiline"],
		"array-bracket-spacing": ["error", "never"],
		camelcase: [
			"error",
			{
				properties: "never",
			},
		],
	},
};
